#include <windows.h>
#include <stdio.h>
#include "resource.h"

#pragma comment(lib,"winmm.lib")

#define MYWNDTITLE		"MciCdPlayer"

int CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static int	idx = 1,ct = 0;
	static char	buf[256];
	
	switch (uMsg)
	{
	case WM_INITDIALOG:
		if(mciSendString("open cdaudio alias x", 0, 0, 0)){
			MessageBox(hDlg,"CDǂݍ߂܂",MYWNDTITLE,MB_OK);
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		if(mciSendString("set x time format tmsf", 0, 0, 0)){
			MessageBox(hDlg,"^CtH[}bgύXł܂",MYWNDTITLE,MB_OK);
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		if(mciSendString("status x number of tracks", buf, sizeof(buf), 0)){
			MessageBox(hDlg,"CD擾ł܂",MYWNDTITLE,MB_OK);
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		ct = atoi(buf);
		break;
	
	case MM_MCINOTIFY:
		if(idx <= ct && (wParam != MCI_NOTIFY_ABORTED)){
			char	cmd[256],title[256];
			idx ++;
			sprintf(cmd,"play x from %d to %d notify",idx,idx+1);
			mciSendString(cmd, 0, 0, hDlg);
			sprintf(title,"%s [track %d]",MYWNDTITLE,idx);
			SendMessage(hDlg,WM_SETTEXT,0,(LPARAM)title);
		}
		break;
	
	case WM_COMMAND:
		switch(wParam)
		{
		case IDC_PLAY | (BN_CLICKED<<16):	// Đ
			if(idx <= ct){
				char	cmd[256],title[256];
				sprintf(cmd,"play x to %d notify",idx+1);
				mciSendString(cmd, 0, 0, hDlg);
				sprintf(title,"%s [track %d]",MYWNDTITLE,idx);
				SendMessage(hDlg,WM_SETTEXT,0,(LPARAM)title);
			}
			break;
		
		case IDC_STOP | (BN_CLICKED<<16):	// ~
			mciSendString("stop x", 0, 0, 0);
			break;
		
		case IDCANCEL | (BN_CLICKED<<16):	// I
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
		
		default:
			return FALSE;
		}
		break;
	
	case WM_CLOSE:
		mciSendString("stop x", 0, 0, 0);
		mciSendString("close x", 0, 0, 0);
		DestroyWindow(hDlg);
		PostQuitMessage(0);
		break;

	default:
		return FALSE;
	}
	return TRUE;
}// DlgProc

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	HWND hDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, DlgProc);
	ShowWindow(hDlg, nCmdShow);
	
	MSG		msg;
	while(GetMessage(&msg, NULL, 0, 0)) {
		if (IsDialogMessage(hDlg, &msg)) continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain
